#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2200seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2200seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven22004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven22004xi = {
                1:'-1004x-1566y1172z',
                2:'-1034x-1791y748z',
                3:'-1078x-1502y1191z',
                4:'-111x-2124y559z',
                5:'-1122x-1728y769z',
                6:'-1124x-1890y5z',
                7:'-1147x-1434y1209z',
                8:'-1206x-1661y789z',
                9:'-1213x-1363y1228z',
                10:'-1221x-1829y27z',
                11:'-1274x-1289y1246z',
                12:'-1287x-1589y810z',
                13:'-1315x-1762y49z',
                14:'-1330x-1212y1264z',
                15:'-1363x-1513y830z',
                16:'-1382x-1133y1282z',
                17:'-1405x-1690y71z',
                18:'-1429x-1051y1300z',
                19:'-1434x-1434y851z',
                20:'-146x-1099y1899z',
                21:'-1471x-968y1317z',
                22:'-1491x-1614y93z',
                23:'-1501x-1351y871z',
                24:'-1508x-882y1335z',
                25:'-1541x-796y1352z',
                26:'-1563x-1265y891z',
                27:'-1568x-709y1370z',
                28:'-1573x-1533y115z',
                29:'-1590x-621y1387z',
                30:'-1607x-532y1404z',
                31:'-1619x-1176y911z',
                32:'-1619x-444y1421z',
                33:'-1626x-355y1437z',
                34:'-1650x-1447y137z',
                35:'-1671x-1085y931z',
                36:'-1717x-991y951z',
                37:'-1722x-1358y159z',
                38:'-1758x-896y971z',
                39:'-1790x-1265y180z',
                40:'-1794x-798y990z',
                41:'-1824x-700y1010z',
                42:'-1848x-600y1029z',
                43:'-1852x-1169y202z',
                44:'-1867x-500y1049z',
                45:'-1881x-399y1068z',
                46:'-1888x-299y1087z',
                47:'-1890x-198y1106z',
                48:'-1909x-1069y224z',
                49:'-193x-1949y1000z',
                50:'-1960x-967y246z',
                51:'-199x-1071y1910z',
                52:'-2006x-862y268z',
                53:'-2045x-755y290z',
                54:'-2079x-646y312z',
                55:'-20x-21y2199z',
                56:'-2107x-535y333z',
                57:'-21x-314y2177z',
                58:'-221x-2110y580z',
                59:'-251x-1041y1921z',
                60:'-293x-1926y1020z',
                61:'-299x-1008y1932z',
                62:'-31x-1146y1877z',
                63:'-331x-2089y602z',
                64:'-33x-39y2199z',
                65:'-345x-972y1942z',
                66:'-34x-290y2180z',
                67:'-388x-935y1952z',
                68:'-391x-1898y1039z',
                69:'-428x-896y1962z',
                70:'-438x-2063y623z',
                71:'-44x-59y2198z',
                72:'-465x-855y1972z',
                73:'-46x-267y2183z',
                74:'-488x-1865y1059z',
                75:'-499x-812y1982z',
                76:'-529x-769y1991z',
                77:'-53x-79y2197z',
                78:'-544x-2031y644z',
                79:'-557x-724y2001z',
                80:'-55x-243y2185z',
                81:'-581x-1827y1078z',
                82:'-581x-679y2010z',
                83:'-5x-336y2174z',
                84:'-5x-5y2199z',
                85:'-602x-633y2019z',
                86:'-60x-101y2196z',
                87:'-615x-113y2109z',
                88:'-619x-586y2027z',
                89:'-629x-150y2102z',
                90:'-62x-218y2188z',
                91:'-634x-540y2036z',
                92:'-640x-188y2096z',
                93:'-645x-494y2044z',
                94:'-648x-1994y665z',
                95:'-649x-229y2089z',
                96:'-653x-448y2052z',
                97:'-655x-270y2082z',
                98:'-658x-402y2060z',
                99:'-659x-313y2075z',
                100:'-65x-123y2195z',
                101:'-660x-357y2067z',
                102:'-66x-194y2190z',
                103:'-672x-1783y1097z',
                104:'-67x-146y2194z',
                105:'-68x-170y2192z',
                106:'-749x-1951y686z',
                107:'-760x-1736y1116z',
                108:'-840x-709y1905z',
                109:'-845x-1683y1135z',
                110:'-847x-1903y707z',
                111:'-853x-799y1980z',
                112:'-861x-652y1916z',
                113:'-878x-595y1926z',
                114:'-892x-539y1937z',
                115:'-89x-1124y1888z',
                116:'-901x-482y1947z',
                117:'-908x-426y1957z',
                118:'-911x-370y1967z',
                119:'-91x-1966y981z',
                120:'-926x-1627y1154z',
                121:'-942x-1849y727z',
                122:'0x-2133y538z'}
         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2200seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2200seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2200SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2200SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2200SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2200SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2200SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven22004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2200SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2200SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2200SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven22004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven22004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2200SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2200SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2200SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2200seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       